;
;               U S G A R D   S C R E E N   C A P T U R E
;                               (usgcap, usc)
;                           written by Andreas Ess
;
;This is a cool demo TSR to make screenshots.
;
#include "usgard.h"

.org 0

.db     "USC! 0.91 by AE",0

Start:
	call    CLEARLCD
	ld      HL, VIDEO_MEM
	ld      B, 112
FillLoop:
	ld      (HL), 255
	inc     HL
	djnz    FillLoop

	ld      HL, $0001
	ld      (CURSOR_ROW), HL
	ld      HL, $0028
	ld      (CURSOR_X), HL

	set     3, (iy+5)
	ld      HL, (PROGRAM_ADDR)      ;PROGRAM_ADDR = Title
	push    HL
	call    D_ZM_STR
	pop     HL
	res     3, (iy+5)

;Check if TSR is already installed using CHECK_APPEND.
; HL -> code to check (PROGRAM_ADDR)
	push    HL
	call    CHECK_APPEND
	pop     DE
	jr      z, InstallTSR
	jr      c, RemoveTSR
	ld      HL, &RemoveError
	jr      WriteText

InstallTSR:

	ld      HL, &TSRRoutine         ;...or use the & operator to add (PROGRAM_ADDR)
	ld      BC, RoutineEnd-TSRRoutine
	call    APPEND
	jr      c, InstallError
	push    HL
	ld      D, H
	ld      E, L
	inc     HL
	ld      (HL), E
	inc     HL
	ld      (HL), D
	pop     HL
	call    INT_INSTALL             ;Install the interrupt!
	jr      nc, InstallOk
	call    UNAPPEND
InstallError:
	ld      HL, &InstallErrorTxt
	jr      WriteText
InstallOk:
	ld      HL, &Installed

WriteText:
	call    D_ZT_STR

	call    OTH_PAUSE
	ret
RemoveTSR:
	call    INT_REMOVE
	call    UNAPPEND

	ld      hl, &Removed
	jr      WriteText

TSRRoutine:
	ld      DE, 0
	in      A, (3)                  ;Check ON
	bit     3, A
	ret     nz
	ld      A, %10111111            ;Check F1
	out     (1), A
	in      A, (1)
	bit     4, A
	ret     nz
	push    IX
	ld      HL, Capture-TSRRoutine
	add     HL, DE
	push    HL
	pop     ix
StartCompare:
	inc     (IX+4)
	ld      BC, 1026
	ld      A, $0C
	call    VAR_NEW
	jr      c, Error
	ld      (HL), 0
	inc     HL
	ld      (HL), $7D
	inc     HL
	ex      DE, HL
	ld      HL, VIDEO_MEM
	ld      BC, 1024
	ldir
Error:
WaitON:
	in      A, (3)
	bit     3, A
	jr      z, WaitON
	pop     IX
	ret
Capture:
	.db     "USC_"
Number:
	.db     "0",0
RoutineEnd:

Installed:
	;012345678901234567890
 .db    "Activate = ON + F1",0
Removed:
 .db    "Removed",0
RemoveError:
 .db    "Error removing!",0
InstallErrorTxt:
 .db    "Error installing!",0

.end
